%MACRO CUSP1(A1CUSP1=,
	A2CUSP1=,
	A3CUSP1=);
%LET D=0.1;


data _null_;
set mcusp1;
CALL SYMPUT("NUMBER",PUT(LNUMBER,4.0));
CALL SYMPUT("T",PUT(LT,5.1));
CALL SYMPUT("LBOUND",PUT(LLBOUND,4.1));
CALL SYMPUT("CILEVEL",PUT(LCILEVEL,4.1));
run;


%IF %UPCASE(&A2CUSP1)=Y %THEN %DO;
data _null_;
set ev1;
CALL SYMPUT("ULOW",PUT(LULOW,4.0));
CALL SYMPUT("UHIGH",PUT(LUHIGH,4.0));
CALL SYMPUT("UINCRE",PUT(LUINCRE,4.0));
CALL SYMPUT("UDIV",PUT(LUDIV,4.0));
CALL SYMPUT("CVLOW",PUT(LCVLOW,4.0));
CALL SYMPUT("CVHIGH",PUT(LCVHIGH,4.0));
CALL SYMPUT("CVINCRE",PUT(LCVINCRE,4.0));
CALL SYMPUT("CVDIV",PUT(LCVDIV,4.0)); 
RUN;
%END;
%ELSE %IF %UPCASE(&A2CUSP1)=N %THEN %DO;
data _null_;
CALL SYMPUT("ULOW",PUT(950,4.0));
CALL SYMPUT("UHIGH",PUT(1000,4.0));
CALL SYMPUT("UINCRE",PUT(50,4.0));
CALL SYMPUT("UDIV",PUT(10,4.0));
CALL SYMPUT("CVLOW",PUT(10,4.0));
CALL SYMPUT("CVHIGH",PUT(40,4.0));
CALL SYMPUT("CVINCRE",PUT(30,4.0));
CALL SYMPUT("CVDIV",PUT(10,4.0)); 
RUN;
%END;

%IF %UPCASE(&A3CUSP1)=Y %THEN %DO;
data _null_;
set smp1;
CALL SYMPUT("MEAN",PUT(LMEAN,6.3));
CALL SYMPUT("CV",PUT(LCV,6.3));
CALL SYMPUT("LCV",PUT(LCV,6.3));  

run;
%END;
%IF %UPCASE(&A3CUSP1)=N %THEN %DO;
data _null_;
CALL SYMPUT("MEAN",PUT(100,6.3));
CALL SYMPUT("CV",PUT(4,6.3));
CALL SYMPUT("LCV",PUT(4,6.3));  
run;
%END;

%macro c1calc;
TARGET = &T;
mu=LLU;
n1=10;
n2=30;
k1=2.4;
k2=2.0;
L1=15;
L2=25;
if TARGET LE 101.5 then E =101.5;
else E = TARGET;

z1=(E-mu)*sqrt(n1)/sigma;
z2=(98.5-mu)*sqrt(n1)/sigma;
chi1=probchi((n1-1)*L1**2/(k1*sigma)**2, n1-1);
int1=(probnorm(z1)-probnorm(z2))*chi1;
t=1;
h=0.05;
int2=0;
do x=E to (E+15-h) by h;
x1=(x-mu)*sqrt(n1)/sigma;
x2=(x+h-mu)*sqrt(n1)/sigma;
chi2=(n1-1)*(E+15-x-h/2)**2/(k1*sigma)**2;
int2=int2+(probnorm(x2)-probnorm(x1))*probchi(chi2, n1-1);
end;

int3=0;
do x=(98.5-15) to (98.5-h) by h;
x1=(x-mu)*sqrt(n1)/sigma;
x2=(x+h-mu)*sqrt(n1)/sigma;
chi3=(n1-1)*(15-98.5+x+h/2)**2/(k1*sigma)**2;
int3=int3+(probnorm(x2)-probnorm(x1))*probchi(chi3, n1-1);
end;

P1=int1+int2+int3;


zz1=(E-mu)*sqrt(n2)/sigma;
zz2=(98.5-mu)*sqrt(n2)/sigma;
cchi1=probchi((n2-1)*L1**2/(k2*sigma)**2, n2-1);
iint1=(probnorm(zz1)-probnorm(zz2))*cchi1;
iint2=0;
do xx=E to (E+15-h) by h;
xx1=(xx-mu)*sqrt(n2)/sigma;
xx2=(xx+h-mu)*sqrt(n2)/sigma;
cchi2=(n2-1)*(E+15-xx-h/2)**2/(k2*sigma)**2;
iint2=iint2+(probnorm(xx2)-probnorm(xx1))*probchi(cchi2, n2-1);
end;

iint3=0;
do xx=(98.5-15) to (98.5-h) by h;
xx1=(xx-mu)*sqrt(n2)/sigma;
xx2=(xx+h-mu)*sqrt(n2)/sigma;
cchi3=(n2-1)*(15-98.5+xx+h/2)**2/(k2*sigma)**2;
iint3=iint3+(probnorm(xx2)-probnorm(xx1))*probchi(cchi3, n2-1);
end;

P2a=iint1+iint2+iint3;

zzz1=(123.125-mu)/sigma;
if TARGET LE 101.5 then zzz2=(101.5-24.625-mu)/sigma;
else zzz2 = (TARGET-24.625-mu)/sigma;

P2b=(probnorm(zzz1)-probnorm(zzz2))**30;

P2=max(0, P2a+P2b-1);

overlbd=max(P1, P2);

mu=ULU;
n1=10;
n2=30;
k1=2.4;
k2=2.0;
L1=15;
L2=25;


z1=(E-mu)*sqrt(n1)/sigma;
z2=(98.5-mu)*sqrt(n1)/sigma;
chi1=probchi((n1-1)*L1**2/(k1*sigma)**2, n1-1);
int1=(probnorm(z1)-probnorm(z2))*chi1;
t=1;
h=0.05;
int2=0;
do x=E to (E+15-h) by h;
x1=(x-mu)*sqrt(n1)/sigma;
x2=(x+h-mu)*sqrt(n1)/sigma;
chi2=(n1-1)*(E+15-x-h/2)**2/(k1*sigma)**2;
int2=int2+(probnorm(x2)-probnorm(x1))*probchi(chi2, n1-1);
end;

int3=0;
do x=(98.5-15) to (98.5-h) by h;
x1=(x-mu)*sqrt(n1)/sigma;
x2=(x+h-mu)*sqrt(n1)/sigma;
chi3=(n1-1)*(15-98.5+x+h/2)**2/(k1*sigma)**2;
int3=int3+(probnorm(x2)-probnorm(x1))*probchi(chi3, n1-1);
end;

P1=int1+int2+int3;


zz1=(E-mu)*sqrt(n2)/sigma;
zz2=(98.5-mu)*sqrt(n2)/sigma;
cchi1=probchi((n2-1)*L1**2/(k2*sigma)**2, n2-1);
iint1=(probnorm(zz1)-probnorm(zz2))*cchi1;
iint2=0;
do xx=E to (E+15-h) by h;
xx1=(xx-mu)*sqrt(n2)/sigma;
xx2=(xx+h-mu)*sqrt(n2)/sigma;
cchi2=(n2-1)*(E+15-xx-h/2)**2/(k2*sigma)**2;
iint2=iint2+(probnorm(xx2)-probnorm(xx1))*probchi(cchi2, n2-1);
end;

iint3=0;
do xx=(98.5-15) to (98.5-h) by h;
xx1=(xx-mu)*sqrt(n2)/sigma;
xx2=(xx+h-mu)*sqrt(n2)/sigma;
cchi3=(n2-1)*(15-98.5+xx+h/2)**2/(k2*sigma)**2;
iint3=iint3+(probnorm(xx2)-probnorm(xx1))*probchi(cchi3, n2-1);
end;

P2a=iint1+iint2+iint3;

zzz1=(123.125-mu)/sigma;
if TARGET LE 101.5 then zzz2=(101.5-24.625-mu)/sigma;
else zzz2 = (TARGET-24.625-mu)/sigma;

P2b=(probnorm(zzz1)-probnorm(zzz2))**30;

P2=max(0, P2a+P2b-1);

overubd=max(P1, P2);

   OVERBD = MIN(OVERLBD, OVERUBD);
%mend c1calc;

%MACRO CALCUSP1;
DATA TAB;
LABEL OVERBD = 'OVERALL LOWER BOUND'
       MEAN = 'SAMPLE MEAN(%CLAIM)';
   D=&D;
   Z = PROBIT((1 + SQRT(&CILEVEL / 100)) / 2);
   N = &NUMBER;
   CHI = CINV(1 - SQRT(&CILEVEL / 100),N - 1);
   SDOLD = 0;
   STARTSD = 0.01;
   DO MEAN = 85.1 TO 114.9 BY D;
      BEGIN = STARTSD;
    DO SAMPSD = BEGIN TO 7.8 BY 0.001;
    SIGMA = SQRT((N - 1) * SAMPSD * SAMPSD / CHI);
    LLU = MEAN - Z *SIGMA / SQRT(N);
    ULU = MEAN + Z * SIGMA / SQRT(N);
%c1calc
   IF OVERBD < &LBOUND/100 AND SAMPSD <= 0.0101 THEN DO;
   CV = 0; OUTPUT; SAMPSD = 20.0; GOTO NEXTT; END;
   IF OVERBD < &LBOUND/100 THEN DO;
      SAMPSD = SAMPSD - 0.001;
      IF SAMPSD < SDOLD THEN DO;
         STARTM = MEAN;
         GOTO UPPER;
          END;
      SDOLD = SAMPSD;
      STARTSD = SAMPSD;
      CV = 100 * SAMPSD / MEAN;
       OUTPUT;
       SAMPSD = 20.0;
       END;
    NEXTT:
     END;
    END;
    GOTO FINISH;
    UPPER:
          STARTSD = 0.01;

   DO MEAN = 114.9 TO STARTM BY -D;
    DO SAMPSD = STARTSD TO 7.8 BY 0.001;
    SIGMA = SQRT((N - 1) * SAMPSD * SAMPSD / CHI);
    LLU = MEAN - Z *SIGMA / SQRT(N);
    ULU = MEAN + Z * SIGMA / SQRT(N);
%c1calc
   IF OVERBD < &LBOUND/100 AND SAMPSD <= 0.0101 THEN DO;
   CV = 0; OUTPUT; SAMPSD = 20.0; GOTO NEXTB; END;
   IF OVERBD < &LBOUND/100 THEN DO;
      SAMPSD = SAMPSD - 0.001;
      STARTSD = SAMPSD;
      CV = 100 * SAMPSD / MEAN;
       OUTPUT;
       SAMPSD = 20.0;
       END;
    NEXTB:
     END;
    END;
  FINISH:
  KEEP CV MEAN;
PROC SORT DATA=TAB; BY MEAN;
DATA
     ONE(RENAME = (MEAN = X1 CV = CV1))
     TWO(RENAME = (MEAN = X2 CV = CV2))
     THREE(RENAME = (MEAN = X3 CV = CV3))
     FOUR(RENAME = (MEAN = X4 CV = CV4))
     FIVE(RENAME = (MEAN = X5 CV = CV5))
     SIX(RENAME = (MEAN = X6 CV = CV6));
 SET TAB;
 IF MEAN <= 90.05 THEN OUTPUT ONE;
 IF 90.05 < MEAN <=  95.05 THEN OUTPUT TWO;
 IF 95.05   < MEAN <= 100.05  THEN OUTPUT THREE;
 IF 100.05  < MEAN <= 105.05  THEN OUTPUT FOUR;
 IF 105.05  < MEAN <= 110.05  THEN OUTPUT FIVE;
 IF 110.05  < MEAN <= 115.0  THEN OUTPUT SIX;
DATA SEVEN;
   MERGE ONE TWO THREE FOUR FIVE SIX;
RUN;
%MEND CALCUSP1;

%MACRO PRTCUSP1;
OPTIONS MISSING = ' ' NODATE NONUMBER;
OPTIONS LS=132;
PROC PRINT DATA=SEVEN SPLIT = '*';
   FORMAT CV1 CV2 CV3 CV4 CV5 CV6 5.2;
   LABEL
         X1 = '  MEAN*(% CLAIM)'
         X2 = '  MEAN*(% CLAIM)'
         X3 = '  MEAN*(% CLAIM)'
         X4 = '  MEAN*(% CLAIM)'
         X5 = '  MEAN*(% CLAIM)'
         X6 = '  MEAN*(% CLAIM)'
         CV1 = 'CV*(%)'
         CV2 = 'CV*(%)'
         CV3 = 'CV*(%)'
         CV4 = 'CV*(%)'
         CV5 = 'CV*(%)'
         CV6 = 'CV*(%)';
      VAR CV1 X2 CV2 X3 CV3 X4 CV4 X5 CV5 X6 CV6;
      ID X1;
TITLE1 "ACCEPTANCE LIMITS FOR CONTENT UNIFORMITY(N=&NUMBER, TARGET = &T)";
TITLE2 "SAMPLING PLAN 1";
TITLE3 "(MEETING LIMITS GUARANTEES, WITH &CILEVEL.% ASSURANCE, THAT AT LEAST";
TITLE4 "&LBOUND.% OF SAMPLES TESTED FOR CONTENT UNIFORMITY WILL PASS THE USP TEST)";
%MEND PRTCUSP1;

%MACRO EVCUSP1;

DATA TAB;
      SET SEVEN;

%MACRO DSCUSP1;
   %DO I = 1 %TO 6;
      DATA DATA&I;
         SET TAB;
         STD = X&I * CV&I / 100; RENAME X&I = X;
         KEEP X&I STD;
   %END;

%MEND DSCUSP1;

%DSCUSP1

DATA ONE;
   SET DATA1 DATA2 DATA3 DATA4 DATA5 DATA6;
   N = &NUMBER;
RUN;

%MACRO SIGCUSP1;

   %DO CV = &CVLOW %TO &CVHIGH %BY &CVINCRE;
      %DO U = &ULOW %TO &UHIGH %BY &UINCRE;

         DATA SAVE;
            SET ONE END = LAST;
            U = &U / &UDIV;
            CV = &CV / &CVDIV;
            SIGMA = U * CV / 100;
            PMEAN = PROBNORM((x - U) * SQRT(N) / SIGMA)
                    - PROBNORM((LAG(X) - U) * SQRT(N) / SIGMA);
            AVEHT = (STD + LAG(STD)) / 2;
            PSTD = PROBCHI((N - 1) * AVEHT * AVEHT
                   / ( SIGMA * SIGMA), N - 1);
            PT = PMEAN * PSTD ;
            PTRAP + PT;
            IF LAST THEN OUTPUT;
         RUN;

PROC APPEND BASE = SAVEALL DATA = SAVE;

       %END;
    %END;

%MEND SIGCUSP1;

%SIGCUSP1

OPTIONS NODATE NONUMBER;
PROC PRINT DATA = SAVEALL split = '*';
   label ptrap = 'PROBABILITY*OF*PASSING';
   VAR CV PTRAP;
   ID U;
TITLE1 "ACCEPTANCE LIMIT TABLE FOR CONTENT UNIFORMITY(N=&NUMBER)";
TITLE2 "SAMPLING PLAN 1";
TITLE3 'DETERMINE PROBABILITY OF PASSING ACCEPTANCE LIMIT TABLE';
TITLE4 "CONFIDENCE LEVEL = &CILEVEL AND LOWER BOUND = &LBOUND";
RUN;
%MEND EVCUSP1;

%MACRO SMPCUSP1;

%let TARGET = &T;
DATA TAB;
LABEL OVERBD = 'OVERALL LOWER BOUND'
       MEAN = 'SAMPLE MEAN(%CLAIM)';
    CILEVEL = &CILEVEL;
   Z = PROBIT((1 + SQRT(&CILEVEL / 100)) / 2);
   N = &NUMBER;
   CHI = CINV(1 - SQRT(&CILEVEL / 100),N - 1);
      MEAN = &MEAN;
      CV = &LCV;
      SAMPSD= &MEAN * CV/100;
    SIGMA = SQRT((N - 1) * SAMPSD * SAMPSD / CHI);
    LLU = MEAN - Z *SIGMA / SQRT(N);
    ULU = MEAN + Z * SIGMA / SQRT(N);
%c1calc

OPTIONS NODATE NONUMBER;
PROC PRINT SPLIT = '*';
  LABEL SAMPSD = 'SAMPLE*STD DEV*(% CLAIM)'
        MEAN = 'SAMPLE* MEAN*(% CLAIM)'
        OVERBD = 'LOWER BOUND';
  ID MEAN;
  VAR SAMPSD CV OVERBD;
TITLE1 "ACCEPTANCE LIMIT TABLE FOR CONTENT UNIFORMITY(N=&NUMBER)";
TITLE2 "SAMPLING PLAN 1";
TITLE3 'DETERMINE PROBABILITY OF FUTURE SAMPLES PASSING THE USP TEST';
TITLE4 "WITH &CILEVEL ASSURANCE FOR GIVEN SAMPLE MEAN AND CV";
run;
%MEND SMPCUSP1;

%MACRO ANACUSP1;
%IF %UPCASE(&A1CUSP1)=Y OR %UPCASE(&A2CUSP1)=Y %THEN %DO;
     %CALCUSP1;
    %END;
%IF %UPCASE(&A1CUSP1)=Y %THEN %DO;
      %PRTCUSP1;
    %END;
%IF %UPCASE(&A2CUSP1)=Y %THEN %DO;
      %EVCUSP1;
PROC DATASETS LIBRARY = WORK;
   DELETE SAVEALL;
   quit;
    %END;
%IF %UPCASE(&A3CUSP1)=Y %THEN %DO;
      %SMPCUSP1;
    %END;
%MEND ANACUSP1;

%ANACUSP1

RUN;
%MEND CUSP1;
%CUSP1

